#include once "camera.bi"



sub camera_struct.update( byref tDelta as single )
	 
	static as single lw, lh
	
	p+=(targ-p)*tDelta*tMul
	
	zoom+=(targZoom-zoom)*tDelta*zoomSpeed
	
	if zoom<.25 then
		zoom = .25
	end if
	
	
	if zoom>4 then
		zoom = 4
	end if
	
	transP = p+vec2f(320,240)
	
	lw = (levWidth*zoom)-640
	lh = (levHeight*zoom)-480
	
	if p.x<0 then
		p.x = 0
	end if

	if p.y<0 then
		p.y = 0
	end if

	if p.x>lw then
		p.x = lw
	end if

	if p.y>lh then
		p.y = lh
	end if
	
	
	if doShake then
		
		shake( shakeMag, shakeTime)
		
	end if
	
end sub


sub camera_struct.shake( byref mag as single, byref length as single  )
	
	if not doShake then
		
		doShake = true
		
		shakeTime = timer+length
		
		shakeMag = mag
		
	end if
	
		p+=vec2f(-shakeMag+rnd*shakeMag*2, -shakeMag+rnd*shakeMag*2)
		
		if timer>shakeTime then doShake = false
	
end sub
