#include once "vec2f.bi"
#include once "display.bi"
#include once "camera.bi"



type line_struct

	as vec2f p1, p2, mp, norm

	as vec2f t1, t2
	
	as rgb_struct col

end type


type model_struct
	
	declare function load( byref fName as string ) as byte
	
	declare function save( byref fName as string ) as byte
	
	declare sub seal()
	
	declare sub transform( byref p as vec2f, byref angle as single, byref scale as single = 1, byref cam as camera_struct, byref forceRot as byte = false)
	
	declare sub center()

	as vec2f posit, centroid

	as integer r

	lines(any) as line_struct

	tLines(any) as line_struct

end type



declare function check_model_model_collision( byref modelA as model_struct, byref pA as vec2f = vec2f(0,0), byref modelB as model_struct, byref pB as vec2f = vec2f(0,0), byref iPoint as vec2f = vec2f(0,0) ) as integer
declare function check_line_model_collision( byref pa as vec2f, byref pb as vec2f, byref model as model_struct, byref p as vec2f, byref iPoint as vec2f = vec2f(0,0) ) as integer
