#include once "mathf.bi"

type vec2f

	declare constructor()

	declare constructor ( byref as vec2f )
	
	declare constructor ( byref x as integer, byref y as integer )

	declare constructor ( byref x as single, byref y as single )

	declare function dist( byref vb as vec2f ) as single

	declare sub normalize()

	declare function perp( byref b as vec2f ) as vec2f

	declare function magnitude( ) as single
	
	declare function cDist( byref v2 as vec2f ) as single
	
	as single x,y

end type


declare operator + ( byval lhs as vec2f, byval rhs as vec2f ) as vec2f
declare operator + ( byval lhs as vec2f, byval rhs as single ) as vec2f
declare operator - ( byval lhs as vec2f, byval rhs as vec2f ) as vec2f
declare operator - ( byval lhs as vec2f, byval rhs as single ) as vec2f
declare operator * ( byval lhs as vec2f, byval rhs as vec2f ) as vec2f
declare operator * ( byval lhs as vec2f, byval rhs as single ) as vec2f
declare operator / ( byval lhs as vec2f, byval rhs as vec2f ) as vec2f
declare operator / ( byval lhs as vec2f, byval rhs as single ) as vec2f
declare operator / ( byval lhs as vec2f, byval rhs as integer ) as vec2f

declare function lines_intersect( byref ipoint as vec2f, byref va as vec2f, byref vb as vec2f, byref vc as vec2f, byref vd as vec2f ) as integer
